--These script needs to run on the primary replica. In my case, primayr replcia is SQLAG1
--Step3: Create a database master key on the primary replica SQLAG1
USE master  
Go
CREATE MASTER KEY ENCRYPTION BY PASSWORD = 'P@ssw0rd123';  
GO
--Step4: Create a certificate to encrypt the endpoints 
USE master  
Go
CREATE CERTIFICATE SQLAG1_Certificate_private
WITH SUBJECT = 'Certificate for the Domainless_SQL_AG SQL Availability Group' 
GO
--Step5: Backup the Certificate
BACKUP CERTIFICATE SQLAG1_Certificate_private
TO FILE = 'c:\temp\SQLAG1_Certificate_private.cert'
GO
--Step6: Create an endpoint for the availability group communication
CREATE ENDPOINT SQLAG_Endpoint
STATE = STARTED
AS TCP
(
	LISTENER_PORT = 5022
)
FOR DATABASE_MIRRORING
(
	AUTHENTICATION = CERTIFICATE SQLAG1_Certificate_private,
	ROLE = ALL, 
	ENCRYPTION = REQUIRED ALGORITHM AES
)

--Step8:  Create a SQL Login on the SQLNode1
CREATE LOGIN SQLAG2Login WITH PASSWORD = 'P@ssw0rd123!'
GO
 
CREATE USER SQLAG2User FOR LOGIN SQLAG2Login
GO
--Step9:Import the public key portion of the certificate from the SQAG2 node
Create CERTIFICATE SQLAG1_public_cert
AUTHORIZATION SQLAG2User
FROM FILE = 'C:\Temp\SQLAG2 Certificate\SQLAG2_Certificate_private.cert'
GO
 --Step10: Grant permissions to connect to endpoint for the SQLAG2Login 
 
GRANT CONNECT ON ENDPOINT::[SQLAG_Endpoint] TO SQLAG2Login
GO


